<?php

namespace Bydedi\Flux\GoogleShopping\Exception;

use Exception;

/**
 * Class LengthParamException
 * @package Bydedi\Flux\GoogleShopping\Exception
 */
class TypeParamException extends Exception
{

    /**
     * TypeParamException constructor.
     * @param string $paramName
     * @param mixed $value
     * @param string $typeAuthorized
     * @param int $code
     * @param Exception|null $previous
     */
    public function __construct($paramName, $value, $typeAuthorized, $code = 0, Exception $previous = null)
    {
        $message = sprintf("Wrong type value of param %s. You set : %s, authorized : %s.", $paramName, gettype($value), $typeAuthorized);
        parent::__construct($message, $code, $previous);
    }

    /**
     * @return string
     */
    public function __toString()
    {
        return __CLASS__ . ": [{$this->code}]: {$this->message}\n";
    }
}